#!/usr/bin/perl

use strict;


package Wiki::Server;
use Wiki::Socket;
use IO::Socket 'PF_INET';


sub run {
  my $semantics = shift;
  my $reqfactory = shift;

  unless (defined $reqfactory) {
    require Wiki::Request;
    $reqfactory = "Wiki::Request";
  }

  my $S = Wiki::Socket->new(Domain => PF_INET, 
                            LocalAddr => 'localhost',
                            LocalPort => 2737,
                            Proto => 'tcp',
                            Listen => 20,
                            ReuseAddr => 1,
                            Blocking => 1,
                           )
    or die "Couldn't create socket: $!";

 Client:
  while (my $c = $S->accept) {
    my $req = $c->get_request($reqfactory) or next Client;
    $req->assign_semantics($semantics);
    eval { $req->execute() };
    if ($@) {
      my $err = "Couldn't execute request: $@";
      warn $err;
      $req->send_response($err);
    } else {
      $req->log();
    }
    undef $req;
    undef $c;
  }
}



1;
