#!/usr/bin/perl

use lib '/home/mjd/public_html/perl/wikisrc/lib';
use Wiki::Action;
use Wiki::Page '/home/mjd/public_html/perl/wikisrc';;
use Wiki::Request;

my $page = shift;
my $ROOT = '/home/mjd/public_html/perl/wikisrc';

my %infile = (RecentChanges => "$ROOT/logs/Log.sig",
              RecentEdits => "$ROOT/logs/Log.min",
             );
my $infile = $infile{$page} || bad($page);
my $outfile = "$infile.cache";

my $req = Wiki::Request->fake;

if (! -e $outfile || -M $infile < -M $outfile) {
  local(*F, *C);
  open F, "<", $infile or error("Couldn't open $page logfile: $!");
  open C, ">", $outfile or error("Couldn't open $page summary cache: $!");
  print C "<table border=0 cellspacing=2>\n";
  local $/ = "\cB";
  my $cur_date;
  while (<F>) {
    chomp;
    my ($time, $type, $who, $host, $page) = split /\cA/;
    $time = localtime($time);
    my $date = substr($time, 4, 6);
    if ($date ne $cur_date) {
      print C qq{<tr><td colspan=5><font size="+1">$date</td></tr>\n};
      $cur_date = $date;
    }
    $page = link_wikiword($req, $page);
    $who = link_wikiword($req, $who) unless $who eq "-";
    $type = Wiki::Action::action(chr($type));
    print C "<tr>", map("<td>$_</td>", substr($time, 10), $type, $who, $page), "</tr>\n";
  }
  print C "</table>\n";
}

open C, "<", $outfile or error("Couldn't open $page summary cache: $!");
print while <C>;

sub bad {
  error("I don't know how to display the page $_[0]");
}

sub error {
  qq{<font color="red">$_[0]</font>};
}

sub link_wikiword {
  my $req = shift;
  my $page = shift;
  if (Wiki::Page::exists($page)) {
    "<a href='" . Wiki::Page::requrl($req, 'View', $page) . "'>$page</a>";
  } else {
    $page . "<a href='" . Wiki::Page::requrl($req, 'View', $page) . "'>?</a>";
  }
}
