#!/usr/bin/perl

use lib '/home/mjd/public_html/perl/wikisrc/lib';
use Wiki::Page '/home/mjd/public_html/perl/wikisrc';;
use Wiki::Request;
use File::Find;

my $page = shift;
my $ROOT = '/home/mjd/public_html/perl/wikisrc';
my $PAGES = '/home/mjd/public_html/perl/wikisrc/pages';

my $outputfile = "$ROOT/logs/pagelist.cache";

unless (-e $outputfile) {
  my @pages;
  open O, ">", $outputfile or die "Couldn't write $outputfile: $!";
  warn "Regenerating page list.\n";
  File::Find::find(\&wanted, $PAGES);
  sub wanted {
    return unless /\.wk$/ && -f && -r;
    my $n = $File::Find::name;
    $n =~ s|^$PAGES/||;
    $n =~ s|\.wk$||;
    push @pages, $n;
  }

  my $req = Wiki::Request->fake;
  my $lasthead = "";
  for my $page (sort {lc $a cmp lc $b} @pages, keys %Wiki::Page::plugins) {
    my $head = substr($page, 0, 1);
    if ($head ne $lasthead) {
      print O "<h2>$head</h2>\n";
      $lasthead = $head;
    }
    print O "<a href='" . Wiki::Page::requrl($req, 'View', $page) . "'>$page</a><br>\n";
  }
  close O;
}

open F, "<", $outputfile or die "Couldn't read $outputfile: $!";
print while <F>;
